
BIC <- function(case,E,coef,X,mu,df){
  n <-length(E)
  
  if(is.null(X)){
    pois.lambda <- E*exp(coef[1]+mu)
  }else{
    pois.lambda <- E*exp(coef[1]+coef[2]*X+mu)
  }
  
  logL <- sum(case*log(pois.lambda)-pois.lambda-lgamma(case+1))  #  Ȯ  !!!!!!!!!
  val <- -2*logL+(log(n)*df)
  return(val)
}

grid.clusters <- function(do.init.0=TRUE, y, X, D, offset, list.lambda, list.gamma, list.delta, gmaxsteps=20, maxsteps=2e3, gconv.eps=1e-4, conv.eps=1e-5, gverbose=FALSE, verbose=FALSE){
   n <- length(y)
  
  nlam <- length(list.lambda)
  ngam <- length(list.gamma)
  ndel <- length(list.delta)

  num <- nlam*ngam*ndel
  bic <- df <- dfb <- dfm <- rep(NA, num)

  mu <- vector(mode="list",length=num)
  coef <-vector(mode="list", length=num)
  
  if(!is.null(X)){
    coef.init <- rep(0, ncol(X)+1)
  }else{
    coef.init <- 0
  }
  mu.init <- rep(0,n)  #initial value of mu

  store <- 0
  min.BIC <- matrix(0, num, 5)
  colnames(min.BIC) <-c("lambda", "gamma", "delta", "df", "bic")
  
  for(i in 1:nlam){
    for(j in 1:ngam){
      for(k in 1:ndel){
        cat("lambda",list.lambda[i],"gamma",list.gamma[j],"delta",list.delta[k],"\n")   #print tuning parameter
        store <- store+1        
        fit <- pglasso(y, X=X, D=D, offset=offset, mu.init=mu.init, beta.init=coef.init, lambda=list.lambda[i], gamma=list.gamma[j], delta=list.delta[k], 
                       gmaxsteps=gmaxsteps, maxsteps=maxsteps, gconv.eps=conv.eps, conv.eps=conv.eps, gverbose=gverbose, verbose=verbose)
        min.BIC[store, c(1,2,3)] <- c(list.lambda[i], list.gamma[j], list.delta[k])

        if(fit$feasibility==TRUE){ 
          #source("pglasso.R")
          #fit <- pglasso(y, X=X, D=D, offset=offset, mu.init=mu.init, beta.init=coef.init, lambda=1, gamma=0, delta=0, maxsteps=maxsteps, gconv.eps=1e-5, conv.eps=1e-5, verbose=TRUE) 
          #mean(fit$mu)      
        
          #coeff
          coef[[store]] <- fit$coefficients                      
          mu[[store]] <- fit$mu
        
          #df
          
          dfb[store] <-  sum(fit$coefficients!=0) 
          dfm[store] <- fit$dfm
	  df[store] <-  dfm[store]+dfb[store]   #df of coef + df of mu
        
          #BIC
          bic[store] <- BIC(case=y, E=offset, coef=fit$coefficients, X=X, mu=fit$mu, df=df[store])          
          min.BIC[store,4] <- df[store]
          min.BIC[store,5] <- bic[store]
        
          #update
          if(!do.init.0){
            mu.init <- fit$mu
            coef.init <- fit$coefficients
          }
        }else{
          df[store] <- NA
          dfb[store] <- NA
          dfm[store] <- NA
          bic[store] <- NA
          min.BIC[store,4] <- NA
          min.BIC[store,5] <- NA 
        }
      }#k
    }#j
  }#i
  if(sum(is.na(bic))==num){
    result <- list(feasibility=FALSE) 
  }else{
    result <- list(feasibility=TRUE, min.bic=min.BIC[which.min(bic),], min.mu=mu[[which.min(bic)]], min.coef=coef[[which.min(bic)]], 
                coef=coef, mu=mu, dfm=dfm,dfb=dfb,df=df, lambda=min.BIC[,1], gamma=min.BIC[,2],delta=min.BIC[,3],bic=bic)
  }
  return(result)
}
