
#specificity calculation

classic.no.cluster <- function(output, First.DataNum, Last.DataNum ){
  
  count.background <- c()   #Number of ["estmated" background cells | "true" background cells]
  UniqueValue.Inbackground <- c()    #In backtrond cluster, unique mu value except zero
  
  for(DataNum in First.DataNum:Last.DataNum){ # check number of cell 
    temp <- output[[DataNum]]$min.mu  #estimated mu of DataNum
    count.background[DataNum] <- length(which(temp==0))  
    UniqueValue.Inbackground[k] <- length(unique(temp[temp != 0]))  #counting except zero
    
  }#DataNum
  
  specificity <- count.background/100
  
  #return value
  list(spec.val= specificity, unique_value_in_background=UniqueValue.Inbackground, count.background=count.background)
  
} 



classic.cluster <- function(output, intend, First.DataNum, Last.DataNum){  #intend means locations of cluster
  
  true.cluster.num <- length(intend)
  
  count.cluster <- c()   #Number of ["estmated" cluster cells | "true" cluster cells]  for each data set
  count.background <- c()  #Number of ["estmated" background cells | "true" background cells]
  UniqueValue.Incluster <- c()    #In true cluster, unique mu value except zero 
  UniqueValue.Inbackground <- c()   #In backtrond cluster, unique mu value except zero
  
  ###counting under condition
  for(DataNum in First.DataNum:Last.DataNum){  
    
    min.mu <- output[[DataNum]]$min.mu
    
    count.cluster[DataNum] <- length(which(min.mu[intend]!=0)) #Number of ["estmated" cluster cells | "true" cluster cells]  for each data set  
    count.background[DataNum] <- length(which(min.mu[-intend]==0))  #Number of ["estmated" background cells | "true" background cells]
    
    temp1 <- min.mu[intend]  # mu value in true cluster
    temp2 <- min.mu[-intend]  #mu value in true background
    
    UniqueValue.Incluster[DataNum] <- length(unique(temp1[temp1 != 0]))   #In true cluster, unique mu value except zero  
    UniqueValue.Inbackground[DataNum] <- length(unique(temp2[temp2 != 0]))  #In backtrond cluster, unique mu value except zero 
  }
  
  sensitivity <- count.cluster/true.cluster.num
  specificity <- count.background/(100-true.cluster.num)
  
  #return value
  list(spec.val=specificity, sens.val=sensitivity, count.cluster=count.cluster, count.background=count.background,
       unique_value_in_cluster=UniqueValue.Incluster, unique_value_in_background=UniqueValue.Inbackground)
}
